export interface AwsLambdaClientContextClientInfo {
    installation_id: string;
    app_title: string;
    app_version_name: string;
    app_version_code: string;
    app_package_name: string;
}
export interface AwsLambdaClientContextEnvInfo {
    platform_version: string;
    platform: string;
    make: string;
    model: string;
    locale: string;
}
export interface AwsLambdaClientContext {
    client: AwsLambdaClientContextClientInfo;
    Custom: any | null;
    env: AwsLambdaClientContextEnvInfo;
}
export interface LambdaContext {
    callbackWaitsForEmptyEventLoop: boolean;
    functionName: string;
    functionVersion: string;
    invokedFunctionArn: string;
    memoryLimitInMB: number;
    awsRequestId: string;
    logGroupName: string;
    logStreamName: string;
    identity: string | null;
    clientContext: AwsLambdaClientContext | null;
}
export declare type AwsLambdaContext = LambdaContext;
export declare type Lambda<T = any, R = any, E = any> = (event: T, context: LambdaContext, callback: (error: E | null, result: R | null) => void) => void;
export declare type AwsLambda = Lambda;
export declare class Lambdas {
    static pipe<T1, R1, E1, R2, E2>(handler1: Lambda<T1, R1, E1>, handler2: Lambda<R1, R2, E2>): Lambda<T1, R2, E1 | E2>;
}
export declare class App {
    private static lambdas;
    private static suppressRun;
    static cli(options: string[], handler: (opts: Map<string, string>) => void): typeof App;
    static route(name: string, lambda: Lambda): typeof App;
    static run(context: any, lambda?: Lambda): void;
}
