"use strict";
// Copyright (c) 2017, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlImposition = exports.Xml = exports.Html5 = exports.Xhtml1_0_Frameset = exports.Xhtml1_0_Transitional = exports.Xhtml1_0_Strict = exports.Html4_01_Frameset = exports.Html4_01_Transitional = exports.Html4_01_Strict = void 0;
/** @jsx RedAgate.createElement */
const RedAgate = require("./red-agate");
// tslint:disable-next-line:class-name
class Html4_01_Strict extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        const x = RedAgate.htmlAttributesRenderer(this.props);
        return `<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"><html${x.attrs}>${x.children}${children}</html>`;
    }
}
exports.Html4_01_Strict = Html4_01_Strict;
// tslint:disable-next-line:class-name
class Html4_01_Transitional extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        const x = RedAgate.htmlAttributesRenderer(this.props);
        return `<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html${x.attrs}>${x.children}${children}</html>`;
    }
}
exports.Html4_01_Transitional = Html4_01_Transitional;
// tslint:disable-next-line:class-name
class Html4_01_Frameset extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        const x = RedAgate.htmlAttributesRenderer(this.props);
        return `<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd"><html${x.attrs}>${x.children}${children}</html>`;
    }
}
exports.Html4_01_Frameset = Html4_01_Frameset;
// tslint:disable-next-line:class-name
class Xhtml1_0_Strict extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        const x = RedAgate.htmlAttributesRenderer(this.props);
        return `<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html${x.attrs}>${x.children}${children}</html>`;
    }
}
exports.Xhtml1_0_Strict = Xhtml1_0_Strict;
// tslint:disable-next-line:class-name
class Xhtml1_0_Transitional extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        const x = RedAgate.htmlAttributesRenderer(this.props);
        return `<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html${x.attrs}>${x.children}${children}</html>`;
    }
}
exports.Xhtml1_0_Transitional = Xhtml1_0_Transitional;
// tslint:disable-next-line:class-name
class Xhtml1_0_Frameset extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        const x = RedAgate.htmlAttributesRenderer(this.props);
        return `<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd"><html${x.attrs}>${x.children}${children}</html>`;
    }
}
exports.Xhtml1_0_Frameset = Xhtml1_0_Frameset;
class Html5 extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        const x = RedAgate.htmlAttributesRenderer(this.props);
        return `<!DOCTYPE html><html${x.attrs}>${x.children}${children}</html>`;
    }
}
exports.Html5 = Html5;
class Xml extends RedAgate.RedAgatePhantomComponent {
    constructor(props) {
        super(props);
    }
    render(contexts, children) {
        return `<?xml version="${typeof this.props.version === 'string' ? this.props.version : '1.0'}" encoding="${typeof this.props.encoding === 'string' ? this.props.encoding : 'UTF-8'}"?>${children}`;
    }
}
exports.Xml = Xml;
class HtmlImposition extends RedAgate.RedAgateComponent {
    constructor(props) {
        super(props);
    }
    transform() {
        const repeater = (Array.isArray(this.props.children) ?
            this.props.children.find(x => typeof x === 'function') :
            this.props.children);
        const a = [];
        const scope = Object.assign({}, this.props.scope || {});
        for (let i = 0; i < this.props.items.length; i++) {
            a.push(RedAgate.createElement("div", { style: {
                    position: 'absolute',
                    left: (this.props.paperWidth / this.props.cols) * (i % this.props.cols),
                    top: (this.props.paperHeight / this.props.rows) * (Math.floor(i / this.props.cols))
                } }, repeater(this.props.items[i], i, this.props.items, scope)));
        }
        return a;
    }
}
exports.HtmlImposition = HtmlImposition;
//# sourceMappingURL=html.js.map