import * as RedAgate from '../red-agate';
import { WebColor } from 'red-agate-svg-canvas/modules/drawing/canvas/WebColor';
import { SvgCanvas } from 'red-agate-svg-canvas/modules/drawing/canvas/SvgCanvas';
export declare const CONTEXT_SVG_CANVAS = "CONTEXT_SVG_CANVAS";
export declare const CONTEXT_SVG_PATH = "CONTEXT_SVG_PATH";
export declare const CONTEXT_ASSET_ = "CONTEXT_ASSET_";
export interface ShapeBaseProps extends RedAgate.ComponentProps {
    x?: number;
    y?: number;
    margin?: number;
}
export interface ShapeProps extends ShapeBaseProps {
    fill?: boolean;
    stroke?: boolean;
    fillColor?: string | WebColor;
    strokeColor?: string | WebColor;
    lineCap?: "butt" | "round" | "square";
    lineJoin?: "miter" | "round" | "bevel";
    lineWidth?: number;
    miterLimit?: number;
    lineDash?: number[];
    lineDashOffset?: number;
}
export interface AmbientProps extends ShapeProps {
    scaleX?: number;
    scaleY?: number;
    rotationDeg?: number;
    tm?: number[];
}
export declare const shapePropsDefault: ShapeProps;
export declare abstract class Shape<T extends ShapeProps> extends RedAgate.RedAgatePhantomComponent<T> {
    protected isAmbient: boolean;
    protected isPathFragment: boolean;
    protected isGroup: boolean;
    constructor(props: T);
    protected initializeCanvas(canvas: SvgCanvas): void;
    protected setGraphicState(canvas: SvgCanvas): void;
    protected restoreGraphicState(canvas: SvgCanvas): void;
    protected fillStrokePaths(canvas: SvgCanvas): void;
    beforeRender(contexts: Map<string, any>): void;
    afterRender(contexts: Map<string, any>): void;
}
export interface ImagingShapeBasePropsMixin {
    asImgTag?: boolean;
    asElementStyle?: boolean;
    asDataUrl?: boolean;
    unit?: string;
}
export interface ImagingShapeBaseProps extends ShapeBaseProps, ImagingShapeBasePropsMixin {
}
export interface ImagingShapeProps extends ShapeProps, ImagingShapeBasePropsMixin {
}
export declare function renderSvgCanvas(props: ImagingShapeBaseProps, canvas: SvgCanvas, imageWidth: number, imageHeight: number): string;
export declare function toImgTag(component: RedAgate.RedAgatePhantomComponent<ImagingShapeBaseProps>): string;
export declare function toElementStyle(component: RedAgate.RedAgatePhantomComponent<ImagingShapeBaseProps>): string;
export declare function toDataUrl(component: RedAgate.RedAgatePhantomComponent<ImagingShapeBaseProps>): string;
export declare function toSvg(component: RedAgate.RedAgatePhantomComponent<ImagingShapeBaseProps>): string;
