import * as RedAgate from './red-agate';
export declare type RepeatRepeater<S> = (times: number, scope: any) => RedAgate.RedAgateNode;
export interface RepeatProps<S> extends RedAgate.ComponentProps {
    times: number;
    scope?: S;
    children?: RepeatRepeater<S> | RedAgate.RedAgateNode | RedAgate.RedAgateNode[];
}
export declare class Repeat<S> extends RedAgate.RedAgateComponent<RepeatProps<S>> {
    constructor(props: RepeatProps<S>);
    transform(): RedAgate.RedAgateNode;
}
export declare type ForEachRepeater<T, S> = (v: any, i: number, items: any[], scope: any) => RedAgate.RedAgateNode;
export interface ForEachProps<T, S> extends RedAgate.ComponentProps {
    items: T[];
    scope?: S;
    children?: ForEachRepeater<T, S> | RedAgate.RedAgateNode | RedAgate.RedAgateNode[];
}
export declare class ForEach<T, S> extends RedAgate.RedAgateComponent<ForEachProps<T, S>> {
    constructor(props: ForEachProps<T, S>);
    transform(): RedAgate.RedAgateNode[];
}
export interface IfProps extends RedAgate.ComponentProps {
    condition: boolean;
}
export declare class If extends RedAgate.RedAgateComponent<IfProps> {
    constructor(props: IfProps);
    transform(): {} | null | undefined;
}
export interface DoProps extends RedAgate.ComponentProps {
}
export declare class Do extends RedAgate.RedAgateComponent<DoProps> {
    constructor(props: DoProps);
    earlyConstruct(): void;
    transform(): never[];
    render(contexts: Map<string, any>, children: string): string;
}
export interface FacetProps extends RedAgate.FragmentProps {
}
export declare class Facet extends RedAgate.Fragment {
    constructor(props: FacetProps);
}
export declare type TemplateProps = FacetProps;
export declare const Template: typeof Facet;
