// Copyright (c) 2017, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
import * as RedAgate from './red-agate';
export class Repeat extends RedAgate.RedAgateComponent {
    constructor(props) {
        super(props);
    }
    transform() {
        const repeater = (Array.isArray(this.props.children) ?
            this.props.children.find(x => typeof x === 'function') :
            this.props.children);
        const a = [];
        const scope = Object.assign({}, this.props.scope || {});
        for (let i = 0; i < this.props.times; i++) {
            a.push(repeater(i, scope));
        }
        return a;
    }
}
export class ForEach extends RedAgate.RedAgateComponent {
    constructor(props) {
        super(props);
    }
    transform() {
        const repeater = (Array.isArray(this.props.children) ?
            this.props.children.find(x => typeof x === 'function') :
            this.props.children);
        const a = [];
        const scope = Object.assign({}, this.props.scope || {});
        for (let i = 0; i < this.props.items.length; i++) {
            a.push(repeater(this.props.items[i], i, this.props.items, scope));
        }
        return a;
    }
}
export class If extends RedAgate.RedAgateComponent {
    constructor(props) {
        super(props);
    }
    transform() {
        if (this.props.condition)
            return this.props.children;
        else
            return [];
    }
}
export class Do extends RedAgate.RedAgateComponent {
    constructor(props) {
        super(props);
        const fn = (Array.isArray(this.props.children) ?
            this.props.children.find(x => typeof x === 'function') :
            this.props.children);
        fn();
    }
    earlyConstruct() { }
    transform() {
        return [];
    }
    render(contexts, children) {
        return ``;
    }
}
export class Facet extends RedAgate.Fragment {
    constructor(props) {
        super(props);
    }
}
export const Template = Facet;
//# sourceMappingURL=taglib.js.map